<style lang="scss" scoped>
.update {
  position: absolute;
  top: 8px;
  right: 8px;
  background: #fff;
  color: #333;
  padding: 4px;
  border-radius: 4px;
  cursor: pointer;
}
</style>
<template>
  <section>
    <div class="mb-5">
      <v-btn color="primary" @click="addInvoice">Add Invoice</v-btn>
    </div>
    <v-row>
      <v-col cols="4" v-for="invoice in $store.state.invoices.invoices" :key="invoice.id">
        <v-card>
          <v-card-text>
            <div class="update" @click="updateInvoice(invoice)">update</div>
            <div>
              <span>ID :</span>
              {{invoice.id}}
            </div>
            <div>
              <span>price :</span>
              ${{invoice.price}}
            </div>
            <div>
              <span>comment :</span>
              {{invoice.comment}}
            </div>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-dialog v-model="dialog" width="500">
      <v-card>
        <v-card-title class="headline">{{update ? 'Update Invoice' : 'Add Invoice'}}</v-card-title>

        <v-card-text>
          <v-text-field type="number" name="name" label="Price" outlined v-model="form.price"></v-text-field>
          <v-text-field name="name" label="Comment" outlined v-model="form.comment"></v-text-field>
        </v-card-text>

        <v-divider></v-divider>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="submit">{{update ? 'Update' : 'Add'}}</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </section>
</template>
<script>
export default {
  data: () => {
    return {
      dialog: false,
      update: null,
      form: {
        price: null,
        comment: null
      }
    };
  },
  watch: {
    dialog() {
      if (this.dialog == false) {
        this.update = null;
      }
    }
  },
  methods: {
    addInvoice() {
      this.dialog = true;
    },
    updateInvoice(invoice) {
      debugger;
      this.dialog = true;
      this.update = Object.assign(invoice);
      this.form.price = this.update.price;
      this.form.comment = this.update.comment;
    },
    reset() {
      this.dialog = false;
      this.form = {
        price: null,
        comment: null
      };
    },
    submit() {
      debugger;
      if (this.update) {
        this.form.id = this.update.id;
        this.$store.dispatch("invoices/Update", this.form);
      } else {
        this.$store.dispatch("invoices/Add", this.form);
      }
      this.reset();
    }
  }
};
</script>